package communication;

import common.CommonVariables;
import engine.GameEngine;
import java.io.IOException;
import javax.microedition.io.StreamConnection;

/**
 * Used for reading and writing in a stream
 * uses the streams 'in' and 'out' in the Commonvariables class
 * 
 * @author sumanta
 */
public class ReadWrite {

    /**
     * reads from the inputstream defined in the CommonVariables class
     * @see common.CommonVariables
     * @return String read
     */
    public static String read() {
        byte[] data = null;
        System.out.println("Inside read method");
        if (CommonVariables.in != null) {
            try {
                
                //first read the length of the incoming string
                int len = CommonVariables.in.read();
                //prepare the data buffer for the string
                data = new byte[len];

                //reinit len, we will use it for validation of length
                len = 0;

                //the following trick is done to read the whole data even
                //if it comes in a bursty manner
                while (len != data.length) {
                    //read(buffer, offset, length)
                    int readLen = CommonVariables.in.read(data, len, data.length - len);
                    if (readLen == -1) {
                        throw new IOException("Can't read data.");
                    }
                    len += readLen;
                }
            } catch (IOException e) {
                System.out.println("Error in read method");
                e.printStackTrace();
            }
        }
        System.out.println("Read: "+new String(data));
        return new String(data);
    }

    /**
     * writes the parameter String to the output stream
     * as stored in the commonvariables class
     * @see common.CommonVariables
     * @param msg
     */
    public static void write( String msg) {
        try {
            System.out.println("Writing: "+msg);
            //CommonVariables.out = conn.openOutputStream();
            CommonVariables.out.write(msg.length()); // length is 1 byte
            CommonVariables.out.write(msg.getBytes());
            
        } catch (IOException e) {
            System.out.println("Error in write method");
            e.printStackTrace();
        }

    }
}
